﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;
using System.ComponentModel.Design.Serialization;

namespace GET_CALCULATION_FANMOTOR
{
    public partial class Form1 : Form
    {
        #region globale Variablen***********************************************
        string errMessage = "";
        int l;
        int n = -1;
        StringBuilder sbKEY = new StringBuilder();
        Char[] chKEY = new Char[5000];
        Double[] dbINPUT = new Double[50];
        //The array size of dbOUTPUT should be 1 more than its equivalent // Die Array Größe von dbOUTPUT sollte um 1 höher sein wie sein Gegenstück 
        //_ array in the DLL, because of the length prefix in Delphi. This // _Array in der DLL, wegen der Längenpräfix in Delphi. Diese 
        //_ length prefix defines the length of the dataset in memory. // _Längenpräfix definiert die Länge des Datensatzes im Speicher.
        //_ Without this prevention the storage position in memory will be // _Ohne diese Vorbeugung wird die Lagerposition im Speicher
        //_ overwritten. // _überschrieben
        Double[] dbOUTPUT = new Double[51];
        int s1 = new int();
        int s2 = new int();
        int z1 = new int();
        int z2 = new int();
        #endregion
        #region DLLImports******************************************************
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string pfad);        // The programm can use the function GetDLLVersion      // Das Programm kann nun diese Funtion benutzen
        //ref allows to modify the contents of variables that's passed to the DLL


        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_PRODUCTS_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]ref string pfad);

        //Important here are the two arrays of double and the one StringBuilder.
        //The StringBuilder acts as an array of char for the Delphi DLL.
        //The calls here are all call by value (no ref, no out).
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_CALCULATION_FANMOTOR(
            int s1, int s2,
            [MarshalAsAttribute(UnmanagedType.LPArray)]Double[] INPUT,
            [MarshalAsAttribute(UnmanagedType.LPStr)]StringBuilder KEY,
            int z1, int z2,
            [MarshalAsAttribute(UnmanagedType.LPArray)]Double[] OUTPUT);

        #endregion
        public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click****************************************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }
        }
        #endregion
        #region btPATH_TO_DATABASE_Click****************************************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n = -1;                                                    // Deklaration of the variable n // Deklaration der Variable n
            string path = "";                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad.");
            }
        }
        #endregion
        #region setPath*********************************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)


            if (File.Exists(path + @"\Data.sqlite"))   // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // If there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // Write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // Show the result // Zeige das Ergebnis
                }
            }
            n = -1;
            return n;
        }
        #endregion
        #region show_Results****************************************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, das die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion
        #region btGetProductsPC_Click*******************************************
        private void btGetProductsPC_Click(object sender, EventArgs e)
        {
            List_Item('P');                             // List the Items (ID and Type) in the listbox and the groupboxes // Liste die Items(ID und Typ) der Listbox und der Groupboxen auf
        }
        #endregion
        #region List_Item*******************************************************
        private void List_Item(char mode)
        {

            int n;                                                              // Declaration of the variable n for the number of products // Deklaration der Variable n für die Anzahl der Produkte    
            string fanStringChar = new string(new Char(), 4000);                // Declaration of the variable fanStringChar for the function GET_PRODUCTS_PC // Deklaration der Variable fanStringChar für die Funktion GET_PRODUCTS_PC

            GC.GetTotalMemory(false);                                           // Free the Memory // Leere den Speicher
            GC.GetTotalMemory(true);                                            // reserve Memory for the function // Reserviere Speicher für die Funktion 

            Clear_Display();                                                    // Delete the Information in the listbox and the comboboxes // Lösche die Informationen in der listbox und der Comboboxen

            n = GET_PRODUCTS_PC(ref fanStringChar);                             // Get the Products n = the number of Products // Hole die Produkte  n = Die anzahl der Produkte bzw Ventilatoren 
            if (n < 0)                                                          // If the number is negative (because u didn´t Set the Path).. // Wenn die Anzahl negativ ist (Weil der Pfad noch nicht gesetzt wurde)
            {
                MessageBox.Show("Der Pfad wurde noch nicht gesetzt!");          // Show a Message that the path wasn´t set // Zeige eine Benachrichtigung, dass der Pfad nicht gesetzt wurde
            }
            else
            {
                show_Results_2(n, fanStringChar);                            // Show the result in the list box and the Comboboxes // Zeige das Ergebnis in der Listbox und den Comboboxen           
            }
        }
        #endregion
        #region Clear_Display***************************************************
        private void Clear_Display()
        {
            lbInfo.Items.Clear();                                               // Delete the information in the listbox // Lösche die Informationen in der listbox
            comBoxIdNo.Items.Clear();                                           // Delete the Information (Product ID) in the Combobox // Lösche die Informationen (Product ID) in der Combobox
            comBoxTyp.Items.Clear();                                            // Delete the information (Type) in the Combobox // Lösche die Informationen (Typ) in der Combobox 
        }
        #endregion
        #region show_Results_2**************************************************
        private void show_Results_2(int n, string FanList) // Function with the parameters: n = number of products; FanList = All the Information(Product ID and Type) of the ventilators // Funktion mit den Parametern : n = Anzahl der Produkte; FanList =  Alle Informationen(Product ID und Typ) zu den Ventilatoren 
        {

            string[] Typen = new string[n + 1];                                 // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen

            string[] IdNo = new string[n + 1];                                  // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID

            int m;                                                              // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'                                                              
            string temp = "";                                                   // Declaration of the variable temp for transporting the product information into the arrays // Deklaration der Variable temp um die Produktinformationen in die Arrays zu transportieren
            int j = 0;                                                          // Declaration of the variable j for the Index of the Arrays // Deklaration der Variable j für den Index der Arrays
            int k;                                                              // Declaration of the variable k for the index of the Array destination // Deklaration der Variable k für den Index des Arrays destination
            tbGetFan.Text = Convert.ToString(n);                                // Write in the second Errorcode textbox the number of ventilators // Schreibe in der zweiten Errorcode Textbox die Anzahl der Ventilatoren 

            char[] thecopy = new char[FanList.Length];                      // Declaration of the Array thecopy for copying the product information  // Deklaration des Arrays thecopy,um die Produktinformationen zu kopieren  

            FanList = FanList.Replace(';', '|');                            // Replace all semicolons in the string with '|' // Ersetze alle Semikolons in dem string durch '|'

            lbInfo.Items.Add("number of existing ventilators:" + Convert.ToString(n));  // Listbox shows the number of ventilators // Die Listbox zeigt die Anzahl der Ventilatoren an


            n = 1;                                                          // Set n = 1 for showing all products (if n = 0 one product is missing)// setze n auf "1" um alle Produkte zu zeigen (bei n = 0 würde eins fehlen)
            while (FanList.Length > 0)                                      // While the Length of the String is bigger than 0 .. // Während die Länge des Strings größer als 0 ist..
            {
                m = FanList.IndexOf('|');                                   // ..set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)                                    // .. delete the values in the array // .. lösche die Werte in dem Array
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           // copy the ID to the char Array and save it in the string temp // Kopiere die ID in das char Array und speichere es in dem string temp 
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                                // increment j as long as a '\0' sign appears // inkrementiere solange bis ein '\0' Zeichen erscheint 
                    }
                }
                IdNo[n] = temp;                                             // copy the ID to the string Array IdNo // kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                         // delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // set j to 0 to count from the beginning // setze j auf 0 um vom Anfang hochzuzählen
                m = FanList.IndexOf('|');                                   // set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           //  Copy the Type to the char Array and save it in the string temp // Kopiere den Typ in das char Array und speichere es in dem string temp
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                               // Increment j as long as a '\0' sign appears // Inkrementiere solange bis ein '\0' Zeichen erscheint  
                    }
                }
                Typen[n] = temp;                                             // Copy the ID to the string Array IdNo // Kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                          // Delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // Delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // Set j to 0 to count from the beginning // Setze j auf 0 um vom Anfang hochzuzählen


                lbInfo.Items.Add("No:  " + Convert.ToString(n) + "  " + IdNo[n] + "  " + Typen[n]); // Show the product information of one product in the listbox // Zeige die Produktinformation eines Produktes in der Listbox
                comBoxIdNo.Items.Add(IdNo[n]);                                                      // Show the ID of one product in the listbox // Zeige die ID eines Produktes in der Combobox                                                      
                comBoxTyp.Items.Add(Typen[n]);                                                      // Show the Type of one product in the listbox // Zeige den Typ eines Produktes in der Combobox 
                n++;                                                                                // increment n to show all products // inkrementiere n um alles Produkte anzuzeigen

            }
            comBoxIdNo.Text = IdNo[1];                                                              // Show the ID of the first product in the Combobox // Zeige die ID des ersten Produkts in der Combobox 
            comBoxTyp.Text = Typen[1];                                                              // Show the Type of the first product in the Combobox // Zeige den Typ des ersten Produkts in der Combobox
        }
        #endregion
        #region Events**********************************************************
        private void comboBoxIdNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changes automatically the value in the text box if the product ID combo box value is changed // Ändert automatisch den Wert in der Textbox, wenn der Wert der product ID combobox sich ändert
            textBoxIdNo.Text = comBoxIdNo.SelectedItem.ToString();
            comBoxTyp.SelectedIndex = comBoxIdNo.SelectedIndex;
            lbInfo.SelectedIndex = comBoxIdNo.SelectedIndex + 1;

        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the listbox and the ID combo boxx if the value is changed // Ändert automatisch den ausgewählten Index der Listbox und der ID Combobox, wenn sich der Wert ändert 
            comBoxIdNo.SelectedIndex = comBoxTyp.SelectedIndex;
            lbInfo.SelectedIndex = comBoxTyp.SelectedIndex + 1;

        }

        private void listBoxProducts_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the type combo box and the ID combo box if the value is changed // Ändert automatisch den ausgewählten Index der type Combobox und der ID Combobox, wenn sich der Wert ändert
            if (lbInfo.SelectedIndex != 0 && lbInfo.SelectedIndex != 1)
            {
                comBoxIdNo.SelectedIndex = lbInfo.SelectedIndex - 1;
                comBoxTyp.SelectedIndex = lbInfo.SelectedIndex - 1;
            }

        }
        #endregion
        #region buttonGetCalculationFanmotor_Click******************************
        private void buttonGetCalculationFanmotor_Click(object sender, EventArgs e)
        {
            check_products_prerequisite();
        }

        //Checks if products are loaded to avoid crashes while clicking on buttons // Überprüft, ob die Produkte geladen wurden, um Abstürze zu vermeiden, während man auf die buttons clickt
        private void check_products_prerequisite()
        {
            //If a product is selected, then proceed // Wenn ein Produkt gewählt wurde, fahre fort
            if (tbGetFan.Text != "" && tbErrorcode.Text == "0" && textBoxIdNo.Text != "")
            {
                get_input_value();      // Get the Data // Hole die Daten
                list_item_calculation_fanmotor();   // list the items // Liste die Items auf
            }

            //If no product is selected, clear the fields // Wenn kein Produkt gewählt wurde, lösche die Felder 
            //_ and throw a message // _ und zeige eine Nachricht
            else
            {
                clear_calculation_fanmotor_fields();

                StringBuilder sbMessageBox = new StringBuilder();
                sbMessageBox.Append("A prerequisite is not set! \n");
                sbMessageBox.Append("Please check if you've chosen a product \n");
                sbMessageBox.Append("and if the database is bounded!");
                MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set");
            }
        }
        #endregion
        #region get_input_value()***********************************************
        //Reads the manually specified product data out of the fields // Liest die manuellen spezifizierten Produkt Daten aus den Feldern
        private void get_input_value()
        {
            Array.Clear(dbINPUT, 0, dbINPUT.Length);
            int i = 0;

            //Tries to fill the dbINPUT array with user input values. If the input // Versucht das dbINPUT Array mit Benutzer Input Werten zu füllen. Wenn die Input
            //_ fields are empty, the actual array position will be set with a default value. // _Felder leer sind,wird die aktuelle Array Position mit einem Default Wert gesetzt
            
            try
            {
                if (comboBoxOption.SelectedItem.ToString() != "")
                    dbINPUT[i++] = Convert.ToDouble(comboBoxOption.SelectedItem.ToString());
                else dbINPUT[i++] = 0;
                if (comboBoxMounting.SelectedItem.ToString() != "")
                    dbINPUT[i++] = Convert.ToDouble(comboBoxMounting.SelectedItem.ToString());
                else dbINPUT[i++] = 0;
                if (textBoxAirDensity.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxAirDensity.Text);
                else dbINPUT[i++] = 0;
                if (textBoxAirTemperature.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxAirTemperature.Text);
                else dbINPUT[i++] = 22;
                if (textBoxAltitude.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxAltitude.Text);
                else dbINPUT[i++] = 333;
                if (textBoxAirVolume.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxAirVolume.Text);
                else dbINPUT[i++] = 0;
                if (textBoxSpeedStep.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxSpeedStep.Text);
                else dbINPUT[i++] = 1;
                if (textBoxPressureDifferenceStatic.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxPressureDifferenceStatic.Text);
                else dbINPUT[i++] = 100;
                if (textBoxPressureDifferenceTotal.Text != "")
                    dbINPUT[i++] = Convert.ToDouble(textBoxPressureDifferenceTotal.Text);
                else dbINPUT[i++] = 100;
            }
            //Throws an exception with error message if a letter/character is set into one of the input fields. // Wirft eine Ausnahme mit Error Benachrichtigung wenn ein Buchstabe/Zeichen in einer der Felder gesetzt wurde
            
            catch (FormatException fe)
            {
                errMessage = fe.ToString();
                MessageBox.Show("Only numerary input accepted!", "Wrong input value");
            }

            //Copies the array of chars to a StringBuilder to avoid wrong interpretations with the DLL // Kopiert die char Arrays zu einem StringBuilder um falsche Interpretationen mit der Dll zu vermeiden 
                        
            sbKEY.Append(textBoxIdNo.Text);
            sbKEY.Append(chKEY, sbKEY.Length, chKEY.Length - sbKEY.Length);
        }
        #endregion
        #region  list_item_calculation-fanmotor**********************************
        private void list_item_calculation_fanmotor()
        {
            int errCodeFanmotor = 99;

            errCodeFanmotor = GET_CALCULATION_FANMOTOR(s1, s2, dbINPUT, sbKEY, z1, z2, dbOUTPUT);
            show_Results_Calculation_Fanmotor(errCodeFanmotor);

            //Clearing these arrays and StringBuilder for its next use // Löscht diese Arrays und StringBuilder für ihre nächste Nutzung
            Array.Clear(dbINPUT, 0, dbINPUT.Length);
            Array.Clear(dbOUTPUT, 0, dbOUTPUT.Length);
            sbKEY.Clear();
        }
        #endregion
        #region show_Results_Calculation_Fanmotor*******************************
        //Displays the whole data of a product in the text boxes. // Zeigt die ganzen Daten eines Produkts in einer Textbox an
        private void show_Results_Calculation_Fanmotor(int errCodeFanmotorIntern)
        {
            richTextBoxOutputData.Clear();

            textBoxErrCodeFanmotor.Text = errCodeFanmotorIntern.ToString();

            textBox0.Text = dbOUTPUT[0].ToString("#0.00");
            textBox2.Text = dbOUTPUT[2].ToString("#0.00");
            textBox3.Text = dbOUTPUT[3].ToString("#0.00");
            textBox4.Text = dbOUTPUT[4].ToString("#0.00");
            textBox5.Text = dbOUTPUT[5].ToString("#0.00");
            textBox6.Text = dbOUTPUT[6].ToString("#0.00");
            textBox7.Text = dbOUTPUT[7].ToString("#0.00");
            textBox8.Text = dbOUTPUT[8].ToString("#0.00");
            textBox9.Text = dbOUTPUT[9].ToString("#0.000");
            textBox10.Text = dbOUTPUT[10].ToString("#0.00");
            textBox11.Text = dbOUTPUT[11].ToString("#0.00");
            textBox12.Text = dbOUTPUT[12].ToString("#0.00");
            textBox32.Text = dbOUTPUT[32].ToString("#0.00");
            textBox33.Text = dbOUTPUT[33].ToString("#0.000");
            textBox34.Text = dbOUTPUT[34].ToString("#0.00");
            textBox35.Text = dbOUTPUT[35].ToString("#0.00");
            textBox36.Text = dbOUTPUT[36].ToString("#0.00");
            textBox37.Text = dbOUTPUT[37].ToString("#0.00");
            textBox38.Text = dbOUTPUT[38].ToString("#0.00");
            textBox39.Text = dbOUTPUT[39].ToString("#0.00");

            textBox24.Text = dbOUTPUT[24].ToString("#0.00");
            textBox25.Text = dbOUTPUT[25].ToString("#0.00");
            textBox26.Text = dbOUTPUT[26].ToString("#0.00");
            textBox27.Text = dbOUTPUT[27].ToString("#0.00");
            textBox28.Text = dbOUTPUT[28].ToString("#0.00");
            textBox29.Text = dbOUTPUT[29].ToString("#0.00");
            textBox30.Text = dbOUTPUT[30].ToString("#0.00");
            textBox31.Text = dbOUTPUT[31].ToString("#0.00");

            textBox16.Text = dbOUTPUT[16].ToString("#0.00");
            textBox17.Text = dbOUTPUT[17].ToString("#0.00");
            textBox18.Text = dbOUTPUT[18].ToString("#0.00");
            textBox19.Text = dbOUTPUT[19].ToString("#0.00");
            textBox20.Text = dbOUTPUT[20].ToString("#0.00");
            textBox21.Text = dbOUTPUT[21].ToString("#0.00");
            textBox22.Text = dbOUTPUT[22].ToString("#0.00");
            textBox23.Text = dbOUTPUT[23].ToString("#0.00");

            textBox13.Text = dbOUTPUT[13].ToString("#0.00");
            textBox14.Text = dbOUTPUT[14].ToString("#0.00");
            textBox15.Text = dbOUTPUT[15].ToString("#0.00");

            textBox40.Text = dbOUTPUT[40].ToString("#0.00");
            textBox41.Text = dbOUTPUT[41].ToString("#0.00");
            textBox42.Text = dbOUTPUT[42].ToString("#0.00");

            richTextBoxOutputData.Text += "KEY: " + sbKEY + "\n";
            richTextBoxOutputData.Text += "--------------------------------------------------------------------\n";
            richTextBoxOutputData.Text += "Input: 1=Pfa; 2=Ptot 3=DrehzStufe:\t" + dbINPUT[0].ToString("#0.00") + "\n"; // '0=Pfa; 1=Ptot
            richTextBoxOutputData.Text += "Input: Installationsart:\t" + dbINPUT[1].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Input: Luftdichte Rho [kg/m^3]:\t" + dbINPUT[2].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Input: Lufttemperatur T [°C]:\t" + dbINPUT[3].ToString("#0.00") + "\n";
            //Pay attention on this hop of dbINPUT index! // Beachte den Hüpfer des dbINPUT index!
            richTextBoxOutputData.Text += "Input: Volumenstrom [m^3/h]:\t" + dbINPUT[5].ToString("#0.00") + "\n";
            //Pay attention on this hop of dbINPUT index! // Beachte den Hüpfer des dbINPUT index!
            richTextBoxOutputData.Text += "Input: Druckerhöhung psf [Pa]:\t" + dbINPUT[7].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Input: Druckerhöhung pf [Pa]:\t" + dbINPUT[8].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "--------------------------------------------------------------------\n";

            int i = 2;
            richTextBoxOutputData.Text += "Output: Drehzahl [1/min]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Gesamtwirkunsgrad Eta_tot[%]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Gesamtwirkunsgrad Eta_stat[%]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Wirkungsgrad Motor  Eta_mot[%]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            i = 7;  //Pay attention on this hop of dbINPUT index! // Beachte den Hüpfer des dbINPUT index!
            richTextBoxOutputData.Text += "Output: Druckerhöhung psf [Pa]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Druckerhöhung pf [Pa]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Leistungsaufnahme [W]:\t" + dbOUTPUT[i++].ToString("#0.000") + "\n";
            richTextBoxOutputData.Text += "Output: Stromaufnahme [A]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Anlaufstrom [A]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Anlaufzeit [s]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ges [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Schallleistung ds [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Schallleistung ss [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 62,5 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 125  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 250  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 500  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 1000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 2000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 4000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ds bei 8000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 62,5 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 125  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 250  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 500  Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 1000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 2000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 4000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: LW ss bei 8000 Hz [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: EtaLr [%]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Wellenleistung Laufrad, Pab Mot [W]:\t" + dbOUTPUT[i++].ToString("#0.000") + "\n";
            richTextBoxOutputData.Text += "Einlaufdüsendruck[Pa]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Betriebsfrequenz Frequenzumformer[Hz]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "max. zulässige Betriebsfrequenz Frequenzumformer[Hz]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Minimal zulässiger Abstand Ventilator-Gehäusewand[mm]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Steuerspannung [V]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Elektrische Leistungsaufnahme FW [kW]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Schalleistung-gesamt A-bewertet [dBA]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Schalleistung-Druckseite A-bewertet [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Schalleistung-Saugseite A-bewertetdbA [dB]:\t" + dbOUTPUT[i++].ToString("#0.00") + "\n";
            richTextBoxOutputData.Text += "Output: Fehlerparameter:\t" + dbOUTPUT[0];
        }
        #endregion
        #region clear_calculation_fanmotor_fields*******************************
        //Clears all relevant fields corresponding to the function // Löscht alle relevanten Felder die der Funktion entsprechen
        private void clear_calculation_fanmotor_fields()
        {
            textBoxIdNo.Clear();
            textBoxErrCodeFanmotor.Clear();
            richTextBoxOutputData.Clear();

            //Clears each text box corresponding to its group box // Löscht jede Textbox die der Group box entspricht
            foreach (TextBox txt in groupBox5.Controls.OfType<TextBox>())
            {
                txt.Text = "";
            }
            foreach (TextBox txt in groupBox6.Controls.OfType<TextBox>())
            {
                txt.Text = "";
            }
        }
        #endregion
        #region buttonShowOutputData_Click**************************************
        // You can show and hide the output Data // Damit kann man die Output Daten anzeigen oder verstecken
        private void buttonShowOutputData_Click(object sender, EventArgs e)
        {
            switch (richTextBoxOutputData.Visible)
            {
                case true:
                    richTextBoxOutputData.Visible = false;
                    buttonShowOutputData.Text = "Show Output Data";
                    break;

                case false:
                    richTextBoxOutputData.Visible = true;
                    buttonShowOutputData.Text = "Hide Output Data";
                    break;
            }
        }
        #endregion

        private async void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;

            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis


                await PutTaskDelay();
                List_Item('P');
                await PutTaskDelay();
                check_products_prerequisite();

            }
            catch (Exception ex)
            {

            }
        }

        async Task PutTaskDelay()
        {

            await Task.Delay(1000);
        }


    }
}
