﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;


namespace GET_TECHNICHAL_DATA
{
    public partial class Form1 : Form
    {
        #region DLL Imports**********************************************
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string pfad);        // The programm can use the function GetDLLVersion      // Das Programm kann nun diese Funtion benutzen
        //ref allows to modify the contents of variables that's passed to the DLL


        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_PRODUCTS_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]ref string pfad);

        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_TECHNICAL_DATA_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)] string fanDescription, ref string buffer);
        #endregion

        public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click*********************************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }
        }
        #endregion
        #region btPATH_TO_DATABASE_Click*********************************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n = -1;                                                    // Deklaration of the variable n // Deklaration der Variable n
            string path = "";                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad.");
            }
        }
        #endregion
        #region setPath**************************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)


            if (File.Exists(path + @"\Data.sqlite"))   // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // If there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // Write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // Show the result // Zeige das Ergebnis
                }
            }
            n = -1;
            return n;
        }
        #endregion
        #region show_Results*********************************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, das die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion
        #region btGetProductsPC_Click************************************
        private void btGetProductsPC_Click(object sender, EventArgs e)
        {

            List_Item('P');                             // List the Items (ID and Type) in the listbox and the groupboxes // Liste die Items(ID und Typ) der Listbox und der Groupboxen auf

        }
        #endregion
        #region List_Item************************************************
        private void List_Item(char mode)
        {

            int n;                                                              // Declaration of the variable n for the number of products // Deklaration der Variable n für die Anzahl der Produkte    
            string fanStringChar = new string(new Char(), 4000);                // Declaration of the variable fanStringChar for the function GET_PRODUCTS_PC // Deklaration der Variable fanStringChar für die Funktion GET_PRODUCTS_PC

            GC.GetTotalMemory(false);                                           // Free the Memory // Leere den Speicher
            GC.GetTotalMemory(true);                                            // reserve Memory for the function // Reserviere Speicher für die Funktion 

            Clear_Display();                                                    // Delete the Information in the listbox and the comboboxes // Lösche die Informationen in der listbox und der Comboboxen

            n = GET_PRODUCTS_PC(ref fanStringChar);                             // Get the Products n = the number of Products // Hole die Produkte  n = Die anzahl der Produkte bzw Ventilatoren 
            if (n < 0)                                                          // If the number is negative (because u didn´t Set the Path).. // Wenn die Anzahl negativ ist (Weil der Pfad noch nicht gesetzt wurde)
            {
                MessageBox.Show("Der Pfad wurde noch nicht gesetzt!");          // Show a Message that the path wasn´t set // Zeige eine Benachrichtigung, dass der Pfad nicht gesetzt wurde
            }
            else
            {
                show_Results_2(n, fanStringChar);                            // Show the result in the list box and the Comboboxes // Zeige das Ergebnis in der Listbox und den Comboboxen           
            }
        }
        #endregion
        #region Clear_Display********************************************
        private void Clear_Display()
        {
            lbInfo.Items.Clear();                                               // Delete the information in the listbox // Lösche die Informationen in der listbox
            comBoxIdNo.Items.Clear();                                           // Delete the Information (Product ID) in the Combobox // Lösche die Informationen (Product ID) in der Combobox
            comBoxTyp.Items.Clear();                                            // Delete the information (Type) in the Combobox // Lösche die Informationen (Typ) in der Combobox 
        }
        #endregion
        #region show_Results_2*******************************************
        private void show_Results_2(int n, string FanList) // Function with the parameters: n = number of products; FanList = All the Information(Product ID and Type) of the ventilators // Funktion mit den Parametern : n = Anzahl der Produkte; FanList =  Alle Informationen(Product ID und Typ) zu den Ventilatoren 
        {

            string[] Typen = new string[n + 1];                                 // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen

            string[] IdNo = new string[n + 1];                                  // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID

            int m;                                                              // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'                                                              
            string temp = "";                                                   // Declaration of the variable temp for transporting the product information into the arrays // Deklaration der Variable temp um die Produktinformationen in die Arrays zu transportieren
            int j = 0;                                                          // Declaration of the variable j for the Index of the Arrays // Deklaration der Variable j für den Index der Arrays
            int k;                                                              // Declaration of the variable k for the index of the Array destination // Deklaration der Variable k für den Index des Arrays destination
            tbGetFan.Text = Convert.ToString(n);                                // Write in the second Errorcode textbox the number of ventilators // Schreibe in der zweiten Errorcode Textbox die Anzahl der Ventilatoren 

            char[] thecopy = new char[FanList.Length];                      // Declaration of the Array thecopy for copying the product information  // Deklaration des Arrays thecopy,um die Produktinformationen zu kopieren  

            FanList = FanList.Replace(';', '|');                            // Replace all semicolons in the string with '|' // Ersetze alle Semikolons in dem string durch '|'

            lbInfo.Items.Add("number of existing ventilators:" + Convert.ToString(n));  // Listbox shows the number of ventilators // Die Listbox zeigt die Anzahl der Ventilatoren an


            n = 1;                                                          // Set n = 1 for showing all products (if n = 0 one product is missing)// setze n auf "1" um alle Produkte zu zeigen (bei n = 0 würde eins fehlen)
            while (FanList.Length > 0)                                      // While the Length of the String is bigger than 0 .. // Während die Länge des Strings größer als 0 ist..
            {
                m = FanList.IndexOf('|');                                   // ..set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)                                    // .. delete the values in the array // .. lösche die Werte in dem Array
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           // copy the ID to the char Array and save it in the string temp // Kopiere die ID in das char Array und speichere es in dem string temp 
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                                // increment j as long as a '\0' sign appears // inkrementiere solange bis ein '\0' Zeichen erscheint 
                    }
                }
                IdNo[n] = temp;                                             // copy the ID to the string Array IdNo // kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                         // delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // set j to 0 to count from the beginning // setze j auf 0 um vom Anfang hochzuzählen
                m = FanList.IndexOf('|');                                   // set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           //  Copy the Type to the char Array and save it in the string temp // Kopiere den Typ in das char Array und speichere es in dem string temp
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                               // Increment j as long as a '\0' sign appears // Inkrementiere solange bis ein '\0' Zeichen erscheint  
                    }
                }
                Typen[n] = temp;                                             // Copy the ID to the string Array IdNo // Kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                          // Delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // Delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // Set j to 0 to count from the beginning // Setze j auf 0 um vom Anfang hochzuzählen


                lbInfo.Items.Add("No:  " + Convert.ToString(n) + "  " + IdNo[n] + "  " + Typen[n]); // Show the product information of one product in the listbox // Zeige die Produktinformation eines Produktes in der Listbox
                comBoxIdNo.Items.Add(IdNo[n]);                                                      // Show the ID of one product in the listbox // Zeige die ID eines Produktes in der Combobox                                                      
                comBoxTyp.Items.Add(Typen[n]);                                                      // Show the Type of one product in the listbox // Zeige den Typ eines Produktes in der Combobox 
                n++;                                                                                // increment n to show all products // inkrementiere n um alles Produkte anzuzeigen

            }
            comBoxIdNo.Text = IdNo[1];                                                              // Show the ID of the first product in the Combobox // Zeige die ID des ersten Produkts in der Combobox 
            comBoxTyp.Text = Typen[1];                                                              // Show the Type of the first product in the Combobox // Zeige den Typ des ersten Produkts in der Combobox
        }
        #endregion
        #region Events***************************************************
        private void comboBoxIdNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changes automatically the value in the text box if the product ID combo box value is changed // Ändert automatisch den Wert in der Textbox, wenn der Wert der product ID combobox sich ändert
            textBoxIdNoTechnicalData.Text = comBoxIdNo.SelectedItem.ToString();
            comBoxTyp.SelectedIndex = comBoxIdNo.SelectedIndex;
            lbInfo.SelectedIndex = comBoxIdNo.SelectedIndex + 1;
        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the listbox and the ID combo boxx if the value is changed // Ändert automatisch den ausgewählten Index der Listbox und der ID Combobox, wenn sich der Wert ändert 
            comBoxIdNo.SelectedIndex = comBoxTyp.SelectedIndex;
            lbInfo.SelectedIndex = comBoxTyp.SelectedIndex + 1;
        }

        private void listBoxProducts_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the type combo box and the ID combo box if the value is changed // Ändert automatisch den ausgewählten Index der type Combobox und der ID Combobox, wenn sich der Wert ändert
            if (lbInfo.SelectedIndex != 0 && lbInfo.SelectedIndex != 1)
            {
                comBoxIdNo.SelectedIndex = lbInfo.SelectedIndex - 1;
                comBoxTyp.SelectedIndex = lbInfo.SelectedIndex - 1;
            }
        }
        #endregion
        #region buttonGetTechnicalDataPC_Click***************************
        private void buttonGetTechnicalDataPC_Click(object sender, EventArgs e)
        {
            check_product_prerequisite();
        }
        #endregion
        #region check_product_prerequisite*******************************
        //Checks if products are loaded to avoid crashes while clicking on buttons // Überprüft ob Produkte geladen wurden um einen Absturz zu vermeiden während Buttons angeklickt werden
        private void check_product_prerequisite()
        {
            //When number of elements is not empty and error code is 0, then proceed // Wenn die Anzahl der Elemente nicht leer ist und der Error Code 0, dann fahre fort
            if (tbGetFan.Text != "" && tbErrorcode.Text == "0")
            {                                    
                textBoxErrCodeTechnicalData.Text = Convert.ToString(list_item_Technical_Data()); // Write the Error code in the textbox // Schreibe den Error Code in die Textbox                                                       
            }
        }
        #endregion
        #region list_item_Technical_Data*********************************
        private int list_item_Technical_Data()
        {
            int errCode = 99;                                               // Declaration of the variable errCode for giving the error code // Deklaration der Variable errCode um den Error Code auszugeben
            System.String fanString = textBoxIdNoTechnicalData.Text;        // Declaration of the variable fanString to get the Information //  Deklaration der Variable fanString um die Informationen zu bekommen


            string fanStringChar = new string(new Char(), 4000);            //Initializes fanStringChar with 4000 empty characters // Initialisiere fanStringChar mit 4000 leere Zeichen
            errCode = GET_TECHNICAL_DATA_PC(fanString, ref fanStringChar);  // Get the error code and the values // Hole den Error Code und die Werte
            show_Results_Technical_Data(fanStringChar);                     // Show the values // Zeige die Werte
            return errCode;
        }
        #endregion
        #region show_Results_Technical_Data******************************
        private void show_Results_Technical_Data(string fanStringIntern)
        {
            string[] result = fanStringIntern.Split(new Char[] { ';' });    // Put the Information between a ';' in the array // Setze die Informationen zwischen einem ';' in das Array

            //The \t formats the output listitems with a tabulator separation. // Das /t formatiert Die Output Listitems mit eine Tabulator Trennung
            listBoxTechnicalData.Items.Clear();                             // Delete the list to get only the values you want and not the vales of the product before // Lösche die Liste um nur die Werte zu bekommen die man braucht und nicht die des letzten Produkts
            // Write the values in the textboxes and the listbox // Schreibe die Werte in die Textboxen und in der Listbox
            textBox50.Text = result[4]; listBoxTechnicalData.Items.Add("Type: \t\t" + result[4]);                       
            textBox51.Text = result[3]; listBoxTechnicalData.Items.Add("Max. fan speed: \t" + result[3] + " [1/min]");
            textBox52.Text = result[2]; listBoxTechnicalData.Items.Add("Current draw: \t" + result[2] + " [A]");
            textBox53.Text = result[1]; listBoxTechnicalData.Items.Add("Input power: \t" + result[1] + " [W]");
            textBox54.Text = result[0]; listBoxTechnicalData.Items.Add("Nominal voltage: \t" + result[0] + " [V]");
            textBox55.Text = result[5]; listBoxTechnicalData.Items.Add("Discharge Area: \t" + result[5] + " Hz");
            textBox1.Text = result[6]; listBoxTechnicalData.Items.Add("Frequency: \t" + result[6] );
            textBox2.Text = result[7]; listBoxTechnicalData.Items.Add("Insulation class:: \t" + result[7] );
            textBox3.Text = result[8]; listBoxTechnicalData.Items.Add("Protection class: \t" + result[8] );
            textBox4.Text = result[9]; listBoxTechnicalData.Items.Add("ErP class: \t" + result[9] );
            textBox5.Text = result[12]; listBoxTechnicalData.Items.Add("cos phi: \t" + result[12] );
            textBox6.Text = result[13]; listBoxTechnicalData.Items.Add("Motor pole: \t" + result[13]);
            textBox7.Text = result[15]; listBoxTechnicalData.Items.Add("η es (ERP): \t" + result[15] + " %");
            textBox8.Text = result[10]; listBoxTechnicalData.Items.Add("Discharge area: \t" + result[10] );
        }
        #endregion

        private async void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;




            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis


                await PutTaskDelay();
                List_Item('P');
                await PutTaskDelay();
                check_product_prerequisite();

            }
            catch (Exception ex)
            {

            }
        }

        async Task PutTaskDelay()
        {

            await Task.Delay(1000);
        }
    }
}


