﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;

namespace SEARCH_PRODUCTS
{
    public partial class Form1 : Form
    {
        #region DLLImports********************************************
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string pfad);        // The programm can use the function GetDLLVersion      // Das Programm kann nun diese Funtion benutzen
        //ref allows to modify the contents of variables that's passed to the DLL


        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int GET_PRODUCTS_PC(ref string pfad);

        [DllImport("EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int SEARCH_PRODUCTS([MarshalAs(UnmanagedType.AnsiBStr)] string fanDescription, ref string buffer);
        #endregion

        public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click******************************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }
        }
        #endregion
        #region btPATH_TO_DATABASE_Click******************************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n = -1;                                                    // Deklaration of the variable n // Deklaration der Variable n
            string path = "";                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad.");
            }
        }
        #endregion
        #region setPath***********************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)


            if (File.Exists(path + @"\Data.sqlite"))   // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // If there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // Write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // Show the result // Zeige das Ergebnis
                }
            }
            n = -1;
            return n;
        }
        #endregion
        #region show_Results******************************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, das die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion
        #region btGetProductsPC_Click*********************************
        private void btGetProductsPC_Click(object sender, EventArgs e)
        {
            List_Item('P');                             // List the Items (ID and Type) in the listbox and the groupboxes // Liste die Items(ID und Typ) der Listbox und der Groupboxen auf
        }
        #endregion
        #region List_Item*********************************************
        private void List_Item(char mode)
        {

            int n;                                                              // Declaration of the variable n for the number of products // Deklaration der Variable n für die Anzahl der Produkte    
            string fanStringChar = new string(new Char(), 4000);                // Declaration of the variable fanStringChar for the function GET_PRODUCTS_PC // Deklaration der Variable fanStringChar für die Funktion GET_PRODUCTS_PC

            GC.GetTotalMemory(false);                                           // Free the Memory // Leere den Speicher
            GC.GetTotalMemory(true);                                            // reserve Memory for the function // Reserviere Speicher für die Funktion 

            Clear_Display();                                                    // Delete the Information in the listbox and the comboboxes // Lösche die Informationen in der listbox und der Comboboxen

            n = GET_PRODUCTS_PC(ref fanStringChar);                             // Get the Products n = the number of Products // Hole die Produkte  n = Die anzahl der Produkte bzw Ventilatoren 
            if (n < 0)                                                          // If the number is negative (because u didn´t Set the Path).. // Wenn die Anzahl negativ ist (Weil der Pfad noch nicht gesetzt wurde)
            {
                MessageBox.Show("Der Pfad wurde noch nicht gesetzt!");          // Show a Message that the path wasn´t set // Zeige eine Benachrichtigung, dass der Pfad nicht gesetzt wurde
            }
            else
            {
                show_Results_2(n, fanStringChar);                            // Show the result in the list box and the Comboboxes // Zeige das Ergebnis in der Listbox und den Comboboxen           
            }
        }
        #endregion
        #region Clear_Display*****************************************
        private void Clear_Display()
        {
            lbInfo.Items.Clear();                                               // Delete the information in the listbox // Lösche die Informationen in der listbox
            comBoxIdNo.Items.Clear();                                           // Delete the Information (Product ID) in the Combobox // Lösche die Informationen (Product ID) in der Combobox
            comBoxTyp.Items.Clear();                                            // Delete the information (Type) in the Combobox // Lösche die Informationen (Typ) in der Combobox 
        }
        #endregion
        #region show_Results_2****************************************
        private void show_Results_2(int n, string FanList) // Function with the parameters: n = number of products; FanList = All the Information(Product ID and Type) of the ventilators // Funktion mit den Parametern : n = Anzahl der Produkte; FanList =  Alle Informationen(Product ID und Typ) zu den Ventilatoren 
        {

            string[] Typen = new string[n + 1];                                 // Declaration of a string array for the types // Deklaration eines string Arrays für die Typen

            string[] IdNo = new string[n + 1];                                  // Declaration of a string array for the ID // Deklaration eines string Arrays für die ID

            int m;                                                              // Declaration of the variable m for the number of signs after a '|' // Deklaration der Variable m für die Anzahl der Zeichen nach einem '|'                                                              
            string temp = "";                                                   // Declaration of the variable temp for transporting the product information into the arrays // Deklaration der Variable temp um die Produktinformationen in die Arrays zu transportieren
            int j = 0;                                                          // Declaration of the variable j for the Index of the Arrays // Deklaration der Variable j für den Index der Arrays
            int k;                                                              // Declaration of the variable k for the index of the Array destination // Deklaration der Variable k für den Index des Arrays destination
            tbGetFan.Text = Convert.ToString(n);                                // Write in the second Errorcode textbox the number of ventilators // Schreibe in der zweiten Errorcode Textbox die Anzahl der Ventilatoren 

            char[] thecopy = new char[FanList.Length];                      // Declaration of the Array thecopy for copying the product information  // Deklaration des Arrays thecopy,um die Produktinformationen zu kopieren  

            FanList = FanList.Replace(';', '|');                            // Replace all semicolons in the string with '|' // Ersetze alle Semikolons in dem string durch '|'

            lbInfo.Items.Add("number of existing ventilators:" + Convert.ToString(n));  // Listbox shows the number of ventilators // Die Listbox zeigt die Anzahl der Ventilatoren an


            n = 1;                                                          // Set n = 1 for showing all products (if n = 0 one product is missing)// setze n auf "1" um alle Produkte zu zeigen (bei n = 0 würde eins fehlen)
            while (FanList.Length > 0)                                      // While the Length of the String is bigger than 0 .. // Während die Länge des Strings größer als 0 ist..
            {
                m = FanList.IndexOf('|');                                   // ..set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)                                    // .. delete the values in the array // .. lösche die Werte in dem Array
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           // copy the ID to the char Array and save it in the string temp // Kopiere die ID in das char Array und speichere es in dem string temp 
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                                // increment j as long as a '\0' sign appears // inkrementiere solange bis ein '\0' Zeichen erscheint 
                    }
                }
                IdNo[n] = temp;                                             // copy the ID to the string Array IdNo // kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                         // delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // set j to 0 to count from the beginning // setze j auf 0 um vom Anfang hochzuzählen
                m = FanList.IndexOf('|');                                   // set the number of signs till a '|' was found // .. setze die Anzahl der Zeichen bis ein '|' gefunden wurde
                for (k = 0; k < 50; k++)
                {
                    thecopy[k] = '\0';
                }
                FanList.CopyTo(0, thecopy, 0, m);                           //  Copy the Type to the char Array and save it in the string temp // Kopiere den Typ in das char Array und speichere es in dem string temp
                while (true)
                {
                    if (thecopy[j] == '\0')
                    {
                        break;
                    }
                    else
                    {
                        temp = temp + thecopy[j];
                        j++;                                               // Increment j as long as a '\0' sign appears // Inkrementiere solange bis ein '\0' Zeichen erscheint  
                    }
                }
                Typen[n] = temp;                                             // Copy the ID to the string Array IdNo // Kopiere die ID in das string Array IdNo
                FanList = FanList.Remove(0, m + 1);                          // Delete the ID in the string .. the Length is reduced now // Lösche die ID in dem string .. die Länge ist nun reduziert                                                           
                temp = "";                                                  // Delete the content of temp // Lösche den Inhalt von temp             
                j = 0;                                                      // Set j to 0 to count from the beginning // Setze j auf 0 um vom Anfang hochzuzählen


                lbInfo.Items.Add("No:  " + Convert.ToString(n) + "  " + IdNo[n] + "  " + Typen[n]); // Show the product information of one product in the listbox // Zeige die Produktinformation eines Produktes in der Listbox
                comBoxIdNo.Items.Add(IdNo[n]);                                                      // Show the ID of one product in the listbox // Zeige die ID eines Produktes in der Combobox                                                      
                comBoxTyp.Items.Add(Typen[n]);                                                      // Show the Type of one product in the listbox // Zeige den Typ eines Produktes in der Combobox 
                n++;                                                                                // increment n to show all products // inkrementiere n um alles Produkte anzuzeigen

            }
            comBoxIdNo.Text = IdNo[1];                                                              // Show the ID of the first product in the Combobox // Zeige die ID des ersten Produkts in der Combobox 
            comBoxTyp.Text = Typen[1];                                                              // Show the Type of the first product in the Combobox // Zeige den Typ des ersten Produkts in der Combobox
        }
        #endregion
        #region Event ************************************************
        private void comboBoxIdNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changes automatically the value in the text box if the product ID combo box value is changed // Ändert automatisch den Wert in der Textbox, wenn der Wert der product ID combobox sich ändert
            comBoxTyp.SelectedIndex = comBoxIdNo.SelectedIndex;
            lbInfo.SelectedIndex = comBoxIdNo.SelectedIndex + 1;
        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the listbox and the ID combo boxx if the value is changed // Ändert automatisch den ausgewählten Index der Listbox und der ID Combobox, wenn sich der Wert ändert 
            comBoxIdNo.SelectedIndex = comBoxTyp.SelectedIndex;
            lbInfo.SelectedIndex = comBoxTyp.SelectedIndex + 1;
        }

        private void listBoxProducts_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Changes automatically the selected index of the type combo box and the ID combo box if the value is changed // Ändert automatisch den ausgewählten Index der type Combobox und der ID Combobox, wenn sich der Wert ändert
            if (lbInfo.SelectedIndex != 0 && lbInfo.SelectedIndex != 1)
            {
                comBoxIdNo.SelectedIndex = lbInfo.SelectedIndex - 1;
                comBoxTyp.SelectedIndex = lbInfo.SelectedIndex - 1;
            }
        }
        #endregion
        #region buttonSearchProducts_Click****************************
        private void buttonSearchProducts_Click(object sender, EventArgs e)
        {
            check_search_products('C');
        }
        #endregion
        #region check_search_products*********************************
        private void check_search_products(char Mode)
        {
            double density = 0;
            //When number of elements is not empty and error code is 0, then proceed // Wenn die Anzahl der Elemente nicht leer ist und der Error Code = 0, fahre fort 
            if (tbGetFan.Text != "" && tbErrorcode.Text == "0")
            {
                try
                {
                    density = Convert.ToDouble(textBoxAirDensity.Text);
                }
                catch (FormatException e)
                {
                    MessageBox.Show("Air density is not numerary!");
                }
                if (density < 0.6 || density > 1.45)
                {

                    //Clear the fields corresponding to the button // Lösche die Felder, die dem Button entsprechen
                    //_ and throw a message // _und zeige eine Nachricht
                    StringBuilder sbMessageBoxDensity = new StringBuilder();
                    sbMessageBoxDensity.Append("Density not valid! \n");
                    sbMessageBoxDensity.Append("Allowed values are from [0.6] to [1.45]. \n");
                    sbMessageBoxDensity.Append("For floating values please check if you've wrote ");
                    sbMessageBoxDensity.Append("a comma [,] or dot [.] according to your region!");
                    MessageBox.Show(sbMessageBoxDensity.ToString(), "Density not valid!");
                }
                else
                {
                    switch (Mode)
                    {

                        case 'C':
                            textBoxErrCodeSearchProducts.Text = Convert.ToString(list_item_SearchProducts('C'));
                            break;
                    }
                }
            }

            //Clear the fields corresponding to the button // Lösche die Felder, die dem Button entsprechen
            //_ and throw a message // _und zeige eine Nachricht
            else
            {
                

            }

        }
        #endregion
        #region check_search_products*********************************
        private int list_item_SearchProducts(char Mode)
        {
            //error code//Error Code
            int errCode = 99;
            //IDNo of the required product // IDNo des vorrausgesetzten Products
            String fanString = textBoxAirVolume.Text + ";" + textBoxPressureDifference.Text + ";" + textBoxToleranz.Text + ";" + textBoxAirDensity.Text + ";" + Edit_Breite_Box.Text + ";" + Edit_Hoehe_Box.Text + ";";

            String fanStringChar = new String('0', 4000);

            switch (Mode)
            {
                case 'C':
                    //initializes fan StringChar with 4000 empty characters, used to return to the list of all dimensions in the file "Dimension.csv" packages
                    // Initialisiere fanStringChar mit 4000 leeren Zeichen, die gebraucht wird um zu der Liste aller Maße in dem Daten Paket "Dimension.csv" zurückzugreifen
                    errCode = SEARCH_PRODUCTS(fanString, ref fanStringChar);
                    show_Results_search_products_Data(fanStringChar);
                    break;
            }

            return errCode;
        }
        #endregion
        #region show_Results_search_products_Data*********************
        private void show_Results_search_products_Data(string fanStringChar)
        {
            string[] result = fanStringChar.Split(';');
            int Anz = 0;
            int count1 = 0;
            int count2 = 1;
            int count3 = 2;
            int count4 = 3;
            int count5 = 4;
            int count6 = 5;
            int limit = result.Length - 2;
            //Clear the listbox befor filling it.                                                 /leere die ListBox vor dem Befüllen.
            listBox_search_products.Items.Clear();
            //The "\t" formats the output listitems with a tabulator separation.                  /Das /t formatiert den Inhalt, vom Output, der Listbox mit einer Tabulator-Trennung.
            listBox_search_products.Items.Insert(0, "IdNo\t\tTyp\t\tn [1/min]\t\tPe [W]\t\tηe [%]\t\tErrorCode");
            while (Anz < limit + 1)
            {
                //Limit is the length from result -2 (limit = 41, result = 43),because                      /Limit ist die Länge von result -2 (Limit = 41, result =43);
                //_the value from count1 is in the last step 42 and this Value doesn´t exist and            /_da der Wert von count1 im letzten Schritt 42 wird und dieser Wert nicht existiert,
                //_would be creating an error. So if count1 is bigger than limit, stop adding lines.        /_würde er einen Fehler verursachen. Also wenn count1 größer als Limit ist, stoppe mit dem füllen.
                //_If limit is bigger than count1, Fill the listbox with the values from result             /_Wenn limit größer als count1 ist, Fülle die ListBox mit den Werten von result,
                //_in the right order.                                                                      /_in der richtigen Reihenfolge.   
                if (count1 < limit)
                {
                    listBox_search_products.Items.Add(result[count1] + "\t" + "\t" + result[count2] + "\t" + result[count3] + "\t" + "\t" + result[count4] + "\t" + "\t" + result[count5] + "\t" + "\t" + result[count6]);
                    count1 = count1 + 6;
                    count2 = count2 + 6;
                    count3 = count3 + 6;
                    count4 = count4 + 6;
                    count5 = count5 + 6;
                    count6 = count6 + 6;
                }
                Anz = Anz + 5;
            }
        }
        #endregion

        private async void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;




            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis


                await PutTaskDelay();
                List_Item('P');
                await PutTaskDelay();
                buttonSearchProducts.PerformClick();
           

            }
            catch (Exception ex)
            {

            }
        }

        async Task PutTaskDelay()
        {

            await Task.Delay(1000);
        }
    }
}
