﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;
using Microsoft.VisualBasic;
namespace SET_XML_PATH_PC_Projekt
{
    public partial class Form1 : Form
    {
        #region DLLImports***********************************
        [DllImport(@"EbmPapstFan.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)] // Import a function from the DLL data EbmPapstFan.dll to this programm with the characterset Ansi   // Importiere eine Funktion von der DLL Datei EbmPapstFan.dll zu diesem Programm mit dem Zeichensatz Ansi
        public static extern int SET_XML_PATH_PC([MarshalAsAttribute(UnmanagedType.AnsiBStr)]string parameter);     // The programm can use the function SET_XML_PATH_PC      // Das Programm kann nun die Funtion SET_XML_PATH_PC benutzen
        #endregion
        public Form1()
        {
            InitializeComponent();
        }
        #region btpfad_Click*********************************
        private void btpfad_Click(object sender, EventArgs e)
        {
            string BuPath;                                                                                     // Declaration of the String BuPath // Deklaration des strings BuPath
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();                              // Creation of the FolderBrowserDialog where you can choose the path // FolderBrowser wird erstellt, wo man den Pfad wählen kann
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)                                          // If you click "Ok" on the BrowserDialog // Wenn "Ok" auf dem FolderBrowserDialog geklickt wird
            {
                BuPath = folderBrowserDialog1.SelectedPath;                                                    // Save the path in the variable BuPath // Speichere den Pfad in die Variable BuPath
                DialogResult dialogResult = MessageBox.Show("Wollen sie den Pfad " + BuPath + " übernehmen?", "Pfad übernehmen?", MessageBoxButtons.YesNo); // Message Box appears which asks you whether you want to take the path // Benachrichtigung erscheint welche dich frägt, ob du den Pfad übernehmen möchtest 
                if (dialogResult == DialogResult.Yes)       // If yes is clicked // Wenn Ja gecklickt wurde
                {
                    tbPfad.Text = BuPath;                   // Textbox shows the Path // Die Textbox zeigt den Pfad an
                }
                else if (dialogResult == DialogResult.No)   // If no is clicked // Wenn Nein geklickt wurde
                {
                    MessageBox.Show("Die Verarbeitung wurde abgebrochen"); // Message appears with the content that the processing is stopped // Verarbeitung wird abgebrochen und über eine Benachrichtigung bekanntgegeben
                }
            }           
        }
        #endregion
        #region btPATH_TO_DATABASE_Click ********************
        private void btPATH_TO_DATABASE_Click(object sender, EventArgs e)
        {
            Int32 n = -1;                                                    // Deklaration of the variable n // Deklaration der Variable n
            string path = "";                                                    // Deklaration of the variable path // Deklaration der Variable path

            path = tbPfad.Text;                                             // Save the content of the Textbox(the path) in the varaible path // Speichere den Inhalt der Textbox(den Pfad) in die Variable path          

            n = setPath(path);                                              // Look after the path // Schaue nach dem Pfad

            if (Directory.Exists(path) == false)
            {
                MessageBox.Show("Pfad existiert nicht! Bitte wählen sie einen gültigen Pfad.");
            }
        }
        #endregion
        #region setPath**************************************
        private int setPath(string path)
        {
            Int32 n;                                   // Declaration of the variable n for the error code // Deklaration der Variable n für den Error Code
            Int32 l;                                   // Declaration of the variable l for the length of the path (the number of the used signs)     // Deklaration der Variable l für die Länge des Pfades (die Anzahl der verwendete Zeichen)
                                          

            if (File.Exists(path + @"\Data.sqlite"))   // if the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert 
            {
                l = path.Length;                       // Get the lentgh of the string path and save it // die Länge des strings path wird gespeichert 


                if (path[l - 1] != (';'))              // if there is no semicolon at the end of the Path // Wenn am Ende des Pfades kein Semikolon steht
                {
                    path = path + (';');               // write a semicolon for the function SET_XML_PATH_PC // Füge ein Semikolon hinzu für die Funktion SET_XML_PATH_PC
                    n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                    show_Results(n, path);             // show the result // Zeige das Ergebnis
                }
            }
            n = -1;                                     
            return n;
        }
        #endregion
        #region show_Results*********************************
        public void show_Results(int n, string path)
        {
            int l;                                     // Declaration of the variable l for the length of the string // Deklaration der Variable l für die Länge des Strings
            l = path.Length;                           // Get the length and save it in the variable l // Hole die Länge und speichere sie in der variable l
            if (path[l - 1] == ';')                    // If the last sign in the string is a semicolon.. // Wenn das letze Zeichen im string Pfad ein Semikolon ist.. 
            {
                path = path.Remove(l - 1, 1);          //.. Delete it // ..Lösche es
                if (File.Exists(path + @"\Data.sqlite") == true)  // If the File Data.sqlite exists in the path // Wenn die File Data.sqlite im Pfad existiert  
                {
                    tbPfad.Text = path;                // Write the path in the textbox // schreibe den Pfad in die Textbox
                    tbErrorcode.Text = Convert.ToString(n); // show the Error Code
                }
                else                                   // If the File Data.sqlite doesn´t exist in the path // Wenn die File Data.sqlite nicht im Pfad existiert  
                {
                    tbErrorcode.Text = "-1";           // Write the errorcode -1 in the textbox (Database isn´t available)     
                    tbPfad.Text = "keine Datenbankk vorhanden!" + path + @"\Data.sqlite"; // The Textbox shows the message that the database is not available // Die Textbox zeigt die Nachricht, dass die Datenbank nicht vorhanden ist
                }
            }
        }
        #endregion

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            String[] parms = Environment.GetCommandLineArgs();
            int n;
        




            try
            {
                string path = parms[1];
                tbPfad.Text = path;
                path = parms[1] + (';');
                n = SET_XML_PATH_PC(path);         // Get the Error Code 0 = the database is available; -1 = the database isn´t available // Hole den Errorcode aus der Funktion 0 = Datenbank ist verfügbar -1 = Datanbank ist nicht verfügbar 
                show_Results(n, path);             // Show the result // Zeige das Ergebnis
            }
            catch (Exception ex)
            {
 
            }
        }
    }
}
